(*
  DTween

  The MIT License

  Copyright (c) 2011 Lyna, http://twc.xrea.jp/

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ----------

  XV

    Ver.0.1 11/08/09 *

    Ver.0.2 11/08/11 *TTweenSerial, Parallel, Delay

    Ver.0.3 11/08/12 *TTween.Abort
                     *TColor^vpeBɑΉ
                     *eTween\bh̕p[^ł

    Ver.0.4 11/08/13 *Overwrite@\

    Ver.0.5 11/08/14 *Ύw莞From, Tȍȗ̃vpeBl擾
                      uTween\bhR[_v
                      u߂ăgDC[sꂽ_vɎdlύX
                     *Duration1t[̎ԂɖȂgDC[
                      SerialɒǉۂɁAő2̃gDC[sȂ
                      sC
                     *TTweenCycle\bhǉ
*)
unit DTween;

interface

uses
  Windows, Messages, SysUtils, Classes, MMSystem, Rtti, TypInfo,
  Generics.Collections, DTween.Easing;

type
  ETweenException = class(Exception);
  ITween = interface;

  { gDC[Cxgp̃\bhQ
    \bhȊÔ(ʂ̃\bh葱)荞߂܂ }
  TTweenEventProc = reference to procedure(Sender: ITween);

  { gDC[̓𐧌䂷C^[tF[Xł
    C^[tF[XȂ̂ŁAzQƂɂCtΉ̎Ԃ͂܂ }
  ITween = interface

    { gDC[̓܂ }
    procedure Initialize;

    { gDC[Đ܂
      ĐI(IsCompleted=True)ōēxĂԂƏčĐ܂ }
    procedure Play;

    { gDC[ꎞ~܂
      PlayōĊJ܂}
    procedure Pause;

    { gDC[~܂ }
    procedure Stop;

    { vpeB̒ľ݂oߎԂɉčXVA]ԂԂ܂
      IɎg܂ }
    function Update(const DeltaTime: Cardinal): Cardinal;

    function GetPosition: Cardinal;
    function GetDuration: Cardinal;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);

    { ݂̍Đʒu擾܂ }
    property Position: Cardinal read GetPosition;

    { Đ̌pԂ擾܂ }
    property Duration: Cardinal read GetDuration;

    { ɎsĂgDC[̓㏑邩ǂw肵܂
      TruȅꍇAgDC[̑ΏۂƂȂCX^X̃gDC[~܂
      Falsȅꍇ͐ɎsĂgDC[ɑ΂ĉ܂
      Truew肵ۂ̃gDC[̒~Playɍs邽߁A
      łɎs̃gDC[ɑ΂Đݒ肵Ăɔf܂
      ftHglTTween.DefaultOverwritevpeBɈˑ܂ }
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;

    { gDC[̓w肵܂
      TruȅꍇA1xĐ܂
      FalsȅꍇAlɖ߂ČJԂĐ܂
      ftHgTrueł
      SerialDelayŃbvꍇAbvꂽgDC[͎TrueɂȂ܂ }
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;

    { gDC[ꎞ~ĂꍇTrueԂ܂ }
    property IsPaused: Boolean read GetIsPaused;

    { gDC[̓삪ĂꍇTrueԂ܂ }
    property IsCompleted: Boolean read GetIsCompleted;

    { gDC[ŒlXVxɌĂԏw肵܂ }
    property OnUpdate: TTweenEventProc read GetOnUpdate write SetOnUpdate;

    { gDC[ɌĂԏw肵܂
      StopOnCompleteFalsȅꍇA삪xɃR[܂ }
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

  { gDC[̋N_ƂȂNXł
    CX^XɎg܂(Ă͂Ȃł) }
  TTween = class
  private
    const
      DEFAULT_SPEED = 30;
    class var
      FRefCount: Integer;
      FContext: TRttiContext;
      FList: TList<ITween>;
      FObjTweens: TObjectDictionary<TObject,TList<ITween>>;
      FTimerId: MMRESULT;
      FPrevTime: Cardinal;
      FDefaultOverwrite: Boolean;
      FSpeed: Cardinal;
      FOnBeforeUpdate: TProc;
      FOnAfterUpdate: TProc;
    class procedure AddToPlayList(Obj: TObject; Tween: ITween);
    class procedure RemoveFromPlayList(Obj: TObject; Tween: ITween);
    class procedure TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD); stdcall; static;
    class procedure Update;
    class procedure SetSpeed(const Value: Cardinal); static;
  public
    class constructor Create;
    class destructor Destroy;

    { w肵CX^XɊ֘A铮쒆̃gDC[SĒ~܂
      ȗꍇASĂ̓쒆̃gDC[~܂
      ܂PlayĂȂ́AStopĕʂ̕ϐŕێĂ̓͏܂ }
    class procedure Abort(Obj: TObject = nil);

    { gDC[쐬܂
      ߂lITweenŁAPlay\bhR[ƃgDC[Jn܂
      Obj:
        Ώۂ̃CX^Xw肵܂
      PropName:
        lύXvpeBw肵܂
        擪'$'tƁAFromValueToValue̒l
        gDC[Jn_̃vpeBl̑ΒlɂȂ܂
        Tween(Obj, 'Width', Width, ...)Tween(Obj, '$Width', 0, ...)͓ɂȂ܂
      FromValue:
        vpeB̏lw肵܂
        Βlw肵܂APropName'$'tꍇ͑ΒlɂȂ܂
      ToValue:
        vpeB̏Ilw肵܂
        Βlw肵܂APropName'$'tꍇ͑ΒlɂȂ܂
      Duration:
        FromValueToValueɓB鎞Ԃw肵܂BPʂ̓~bł
      Easing:
        C[WO֐w肵܂(DTweenjbgTEasing̃\bh)
        ȗꍇATEasing.Lineargp܂ }
    class function Tween(Obj: TObject; const PropName: string;
      const FromValue, ToValue: Integer; Duration: Cardinal;
      const Easing: TEasingFunc = nil): ITween; overload;

    { Tween\bh̕p[^łł
      FromValuesToValues͈ȉ̂悤ɃvpeBƒl݂ɋLqĎw肵܂
      ['Left', 100, 'Top', 100] }
    class function Tween(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: TEasingFunc = nil): ITween; overload;

    { Tween\bhFromValueȗłł
      ̏ꍇFromValue̓gDC[Jn_̒lɂȂ܂ }
    class function TweenTo(Obj: TObject; const PropName: string;
      const ToValue: Integer; Duration: Cardinal; const Easing: TEasingFunc = nil): ITween; overload;

    { TweenTo̕p[^łł }
    class function TweenTo(Obj: TObject; const ToValues: array of const;
      Duration: Cardinal; const Easing: TEasingFunc = nil): ITween; overload;

    { Tween\bhToValueȗłł
      ̏ꍇToValue̓gDC[Jn_̒lɂȂ܂ }
    class function TweenFrom(Obj: TObject; const PropName: string;
      const FromValue: Integer; Duration: Cardinal; const Easing: TEasingFunc = nil): ITween; overload;

    { TweenFrom̕p[^łł }
    class function TweenFrom(Obj: TObject; const FromValues: array of const;
      Duration: Cardinal; const Easing: TEasingFunc = nil): ITween; overload;

    { ̃gDC[𒼗Ɍq܂ }
    class function Serial(const Tweens: array of ITween): ITween;

    { ̃gDC[Ɍq܂ }
    class function Parallel(const Tweens: array of ITween): ITween;

    { w肵gDC[̑OɃfBCt܂ }
    class function Delay(const PreDelay, PostDelay: Cardinal;
      const BaseTween: ITween): ITween; static;

    { gDC[w񐔌JԂ܂ }
    class function Cycle(const CycleCount: Cardinal;
      const BaseTween: ITween): ITween; static;

    { egDC[OverwritevpeB̏l`܂
      DefaultOverwriteg̏lTrueł }
    class property DefaultOverwrite: Boolean read FDefaultOverwrite write FDefaultOverwrite;

    { 1bԂ̍XV񐔂w肵܂
      LȒl1`1000ł(A60𒴂Ƃ܂ӖC܂) }
    class property Speed: Cardinal read FSpeed write SetSpeed;

    { et[ŃgDC[s钼OɌĂ΂Cxgł }
    class property OnBeforeUpdate: TProc read FOnBeforeUpdate write FOnBeforeUpdate;

    { et[ŃgDC[sꂽɌĂ΂Cxgł }
    class property OnAfterUpdate: TProc read FOnAfterUpdate write FOnAfterUpdate;
  end;

implementation

uses Math;

{ TAbstractTween }

type
  TAbstractTween = class abstract(TInterfacedObject, ITween)
  private
    FParent: TAbstractTween;
    FIsPaused: Boolean;
    FOverwrite: Boolean;
    FStopOnComplete: Boolean;
    FOnUpdate: TTweenEventProc;
    FOnComplete: TTweenEventProc;
    procedure SetParent(const Value: TAbstractTween);
    function GetPosition: Cardinal;
    function GetDuration: Cardinal;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);
  protected
    FPosition: Cardinal;
    FDuration: Cardinal;
    procedure AddToPlayList(Tween: ITween); virtual;
    procedure RemoveFromPlayList(Tween: ITween); virtual;
    procedure DoOverwrite; virtual;
    property Parent: TAbstractTween read FParent write SetParent;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Initialize; virtual; abstract;
    procedure Play;
    procedure Pause;
    procedure Stop;
    procedure DoUpdate(const DeltaTime: Cardinal); virtual; abstract;
    function Update(const DeltaTime: Cardinal): Cardinal;

    property Position: Cardinal read GetPosition;
    property Duration: Cardinal read GetDuration;
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;
    property IsPaused: Boolean read GetIsPaused;
    property IsCompleted: Boolean read GetIsCompleted;
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

  TObjectTween = class(TAbstractTween)
  private
  type
    // MEMO: ȂTInitValueTChangeValue̗ŏl邩ƂƁA
    // TInitValueValueTween\bhœnꂽ̂܂܂̏lȂ̂ɑ΂āA
    // TChangeValueBaseValue͌vẐ߂ɃVXeJ[GetSysColor̂ێĂ邽
    // TChangeValue.FinishValue݂闝R
    TInitValue = record
      Prop: TRttiProperty;
      IsRelative: Boolean;
      Value: Integer;
    end;
    TChangeValue = record
      Prop: TRttiProperty;
      IsRelative: Boolean;
      BaseValue: Integer;
      FinishValue: Integer;
      case IsColor: Boolean of
        False: (DiffValue: Integer);
        True: (DiffColor: array[0..2] of Integer);
    end;
  var
    FObj: TObject;
    FEasing: TEasingFunc;
    FIsValueFixed: Boolean;
    FInitValues: array of TInitValue;
    FChangeValues: array of TChangeValue;

    procedure CalcValues;
    function GetProperty(const Obj: TObject; const PropName: string;
      out IsRelative: Boolean): TRttiProperty;
    function GetPropAbsoluteValue(const Obj: TObject; const Prop: TRttiProperty;
      const Value: Integer): Integer;
  protected
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
  public
    constructor Create(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: TEasingFunc);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  // q̃gDC[NX͑Sh
  TWrapTween = class abstract(TAbstractTween)
  private
    function GetBaseTween: ITween; inline;
  protected
    FTweens: array of ITween;
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
  public
    constructor Create(const Tweens: array of ITween); overload;
    constructor Create(const BaseTween: ITween); overload;
    property BaseTween: ITween read GetBaseTween;
  end;

  TParallelTween = class(TWrapTween)
  public
    constructor Create(const Tweens: array of ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TSerialTween = class(TWrapTween)
  private
    FTweenIndex: Integer;
  public
    constructor Create(const Tweens: array of ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TDelayedTween = class(TWrapTween)
  private
    FPreDelay: Cardinal;
    FPostDelay: Cardinal;
    FState: (Pre, Proc, Post);
  public
    constructor Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TCycledTween = class(TWrapTween)
  private
    FCurrentCount: Cardinal;
    FCycleCount: Cardinal;
  public
    constructor Create(const CycleCount: Cardinal; const BaseTween: ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

constructor TAbstractTween.Create;
begin
  FIsPaused := True;
  FStopOnComplete := True;
  FOverwrite := TTween.DefaultOverwrite;
  Inc(TTween.FRefCount);
end;

destructor TAbstractTween.Destroy;
begin
  Dec(TTween.FRefCount);
  inherited;
end;

procedure TAbstractTween.AddToPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.RemoveFromPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.DoOverwrite;
begin
end;

procedure TAbstractTween.Play;
begin
  FIsPaused := False;

  if IsCompleted then
    Initialize;

  if not TTween.FList.Contains(Self) then
  begin
    if FOverwrite then
      DoOverwrite;

    TTween.FList.Add(Self);
    AddToPlayList(Self);
  end;
end;

procedure TAbstractTween.Pause;
begin
  FIsPaused := True;
end;

procedure TAbstractTween.Stop;
begin
  FIsPaused := True;

  if TTween.FList.Remove(Self) <> -1 then
  begin
    RemoveFromPlayList(Self);
  end;
end;

function TAbstractTween.Update(const DeltaTime: Cardinal): Cardinal;
begin
  Result := 0;
  if IsPaused or IsCompleted then Exit;

  if DeltaTime > FDuration - FPosition then
    Result := DeltaTime - (FDuration - FPosition);

  Inc(FPosition, DeltaTime);
  if FPosition >= FDuration then
  begin
    FPosition := FDuration;
  end;
  DoUpdate(DeltaTime);
  if Assigned(FOnUpdate) then
    FOnUpdate(Self);
  if IsCompleted and Assigned(FOnComplete) then
    FOnComplete(Self);
end;

procedure TAbstractTween.SetParent(const Value: TAbstractTween);
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă܂');

  FParent := Value;
  Stop;
  StopOnComplete := True;
end;

function TAbstractTween.GetPosition: Cardinal;
begin
  Result := FPosition;
end;

function TAbstractTween.GetDuration: Cardinal;
begin
  Result := FDuration;
end;

function TAbstractTween.GetOverwrite: Boolean;
begin
  Result := FOverwrite;
end;

procedure TAbstractTween.SetOverwrite(const Value: Boolean);
begin
  FOverwrite := Value;
end;

function TAbstractTween.GetStopOnComplete: Boolean;
begin
  Result := FStopOnComplete;
end;

procedure TAbstractTween.SetStopOnComplete(const Value: Boolean);
begin
  FStopOnComplete := Value;
end;

function TAbstractTween.GetIsPaused: Boolean;
begin
  if FParent <> nil then
    Result := FParent.IsPaused
  else
    Result := FIsPaused;
end;

function TAbstractTween.GetIsCompleted: Boolean;
begin
  Result := FPosition >= FDuration;
end;

function TAbstractTween.GetOnUpdate: TTweenEventProc;
begin
  Result := FOnUpdate;
end;

procedure TAbstractTween.SetOnUpdate(const Value: TTweenEventProc);
begin
  FOnUpdate := Value;
end;

function TAbstractTween.GetOnComplete: TTweenEventProc;
begin
  Result := FOnComplete;
end;

procedure TAbstractTween.SetOnComplete(const Value: TTweenEventProc);
begin
  FOnComplete := Value;
end;

{ TObjectTween }

function TObjectTween.GetProperty(const Obj: TObject; const PropName: string;
  out IsRelative: Boolean): TRttiProperty;
var
  typ: TRttiType;
begin
  if Obj = nil then
    raise ETweenException.Create('IuWFNgnilł');

  typ := TTween.FContext.GetType(Obj.ClassType);
  if typ = nil then
    raise ETweenException.CreateFmt('NX %s ̌^擾ł܂', [Obj.ClassName]);

  IsRelative := Pos('$', PropName) = 1;
  if IsRelative then
    Result := typ.GetProperty(Copy(PropName, 2, Length(PropName)))
  else
    Result := typ.GetProperty(PropName);
  if Result = nil then
    raise ETweenException.CreateFmt('w肵vpeB܂ (%s)', [PropName]);

  if Result.PropertyType.TypeKind <> tkInteger then
    raise ETweenException.CreateFmt('Integer^ȊÕvpeB͖Ήł (%s)', [Result.PropertyType.Name]);
  if not Result.IsWritable then
    raise ETweenException.CreateFmt('w肵vpeB͏݂ł܂ (%s)', [PropName]);

  if not Result.IsReadable then
    raise ETweenException.CreateFmt('w肵vpeB͓ǂݍ݂ł܂ (%s)', [PropName]);
end;

// Βl擾
function TObjectTween.GetPropAbsoluteValue(const Obj: TObject; const Prop: TRttiProperty; const Value: Integer): Integer;
var
  i: Integer;
  propValue: Integer;
begin
  if Prop.PropertyType.Name = 'TColor' then
  begin
    Result := 0;
    propValue := Prop.GetValue(Obj).AsInteger;
    if propValue < 0 then
      propValue := GetSysColor(propValue and $000000FF);
    for i := 0 to 2 do
    begin
      LongRec(Result).Bytes[i] := Min(LongRec(propValue).Bytes[i] + LongRec(Value).Bytes[i], 255);
    end;
  end
  else
    Result := Prop.GetValue(Obj).AsInteger + Value;
end;

constructor TObjectTween.Create(const Obj: TObject;
  const FromValues, ToValues: array of const; const Duration: Cardinal;
  const Easing: TEasingFunc);
var
  i, j: Integer;

  function TryGetValue(Prop: TRttiProperty; out Value: Integer; out IsRelative: Boolean): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        IsRelative := FInitValues[i].IsRelative;
        Exit(True);
      end;
    Result := False;
  end;

begin
  inherited Create;

  if Duration = 0 then
    raise ETweenException.Create('pԂɂ̓[傫lw肵ĉ');

  if Odd(Length(FromValues)) then
    raise ETweenException.Create('FromValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if Odd(Length(ToValues)) then
    raise ETweenException.Create('ToValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if (Length(FromValues) = 0) and (Length(ToValues) = 0) then
    raise ETweenException.Create('FromValuesToValues̗A邢͂ꂩЕ1ȏ̃vpeBƒl̃yAw肵ĉ');

  // Ƀ`FbNႤ
  i := 0;
  while i < Length(FromValues) do
  begin
    if FromValues[i].VType <> vtUnicodeString then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if FromValues[i+1].VType <> vtInteger then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂInteger^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

  i := 0;
  while i < Length(ToValues) do
  begin
    if ToValues[i].VType <> vtUnicodeString then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if ToValues[i+1].VType <> vtInteger then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂInteger^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

  FIsValueFixed := False;

  i := 0; j := 0;

  // FromValuesw肳ĂȂꍇToValues̃vpeB̌ݒlݒ
  if Length(FromValues) = 0 then
  begin
    SetLength(FInitValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty(Obj, UnicodeString(ToValues[i].VUnicodeString), IsRelative);
        IsRelative := True;
        Value := 0;
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end
  else begin
    SetLength(FInitValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty(Obj, UnicodeString(FromValues[i].VUnicodeString), IsRelative);
        Value := FromValues[i+1].VInteger;
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  i := 0; j := 0;

  // ToValuesw肳ĂȂꍇFromValues̃vpeB̌ݒlݒ
  if Length(ToValues) = 0 then
  begin
    SetLength(FChangeValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty(Obj, UnicodeString(FromValues[i].VUnicodeString), IsRelative);
        IsRelative := True;
        BaseValue := FromValues[i+1].VInteger;
        FinishValue := 0;
        IsColor := Prop.PropertyType.Name = 'TColor';
      end;
      Inc(i, 2);
      Inc(j)
    end;
  end
  else begin
    SetLength(FChangeValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty(Obj, UnicodeString(ToValues[i].VUnicodeString), IsRelative);
        FinishValue := ToValues[i+1].VInteger;
        IsColor := FChangeValues[j].Prop.PropertyType.Name = 'TColor';
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  FObj := Obj;
  FDuration := Duration;
  FPosition := FDuration;
  if Assigned(Easing) then
    FEasing := Easing
  else
    FEasing := TEasing.Linear;
end;

{ Βl̎s擾ƍvZ }
procedure TObjectTween.CalcValues;
var
  i, j: Integer;
  color: Integer;

  function TryGetInitValue(Prop: TRttiProperty; out Value: Integer): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        Exit(True);
      end;
    Result := False;
  end;

begin
  for i := Low(FInitValues) to High(FInitValues) do
  begin
    with FInitValues[i] do
      if IsRelative then
        Value := GetPropAbsoluteValue(FObj, Prop, Value);
  end;

  for i := Low(FChangeValues) to High(FChangeValues) do
  begin
    with FChangeValues[i] do
    begin
      if not TryGetInitValue(Prop, BaseValue) then
        BaseValue := Prop.GetValue(FObj).AsInteger;

      if IsRelative then
        FinishValue := GetPropAbsoluteValue(FObj, Prop, FinishValue);

      // vZ
      if IsColor then
      begin
        if BaseValue < 0 then
          BaseValue := GetSysColor(BaseValue and $000000FF);
        color := FinishValue;
        if color < 0 then
          color := GetSysColor(color and $000000FF);
        for j := 0 to 2 do
          DiffColor[j] := LongRec(color).Bytes[j] - LongRec(BaseValue).Bytes[j];
      end
      else begin
        DiffValue := FinishValue - BaseValue;
      end;
    end;
  end;

  FIsValueFixed := True;
end;

procedure TObjectTween.AddToPlayList(Tween: ITween);
begin
  TTween.AddToPlayList(FObj, Tween);
end;

procedure TObjectTween.RemoveFromPlayList(Tween: ITween);
begin
  TTween.RemoveFromPlayList(FObj, Tween);
end;

procedure TObjectTween.DoOverwrite;
begin
  TTween.Abort(FObj);
end;

procedure TObjectTween.Initialize;
var
  i: Integer;
begin
  if not FIsValueFixed then
    CalcValues;

  FPosition := 0;
  for i := 0 to High(FInitValues) do
    with FInitValues[i] do
      Prop.SetValue(FObj, Value);
end;

procedure TObjectTween.DoUpdate(const DeltaTime: Cardinal);

  function RoundOff(const Value: Extended): Integer; inline;
  begin
    if Value >= 0 then Result := Trunc(Value + 0.5)
    else Result := Trunc(Value - 0.5);
  end;

var
  i: Integer;
  value: Integer;
begin
  if IsCompleted then
    for i := 0 to High(FChangeValues) do
      with FChangeValues[i] do
        Prop.SetValue(FObj, FinishValue)
  else begin
    for i := 0 to High(FChangeValues) do
    begin
      with FChangeValues[i] do
      begin
        if IsColor then
        begin
          value := RoundOff(FEasing(FPosition, (BaseValue and $FF0000) shr 16, DiffColor[2], FDuration));
          value := value shl 8;
          value := value or RoundOff(FEasing(FPosition, (BaseValue and $FF00) shr 8, DiffColor[1], FDuration));
          value := value shl 8;
          value := value or RoundOff(FEasing(FPosition, BaseValue and $FF, DiffColor[0], FDuration));
          Prop.SetValue(FObj, value);
        end
        else begin
          Prop.SetValue(FObj, RoundOff(FEasing(FPosition, BaseValue, DiffValue, FDuration)));
        end;
      end;
    end;
  end;
end;

{ TGroupTween }

constructor TWrapTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  if Length(Tweens) = 0 then
    raise ETweenException.Create('1ȏITweenw肵ĉ');

  inherited Create;

  FDuration := 0;
  SetLength(FTweens, Length(Tweens));
  for i := Low(FTweens) to High(FTweens) do
  begin
    if Tweens[i] = nil then
      raise ETweenException.CreateFmt('nil͎wł܂ (Tweens[%d] = nil)', [i]);

    FTweens[i] := Tweens[i];
    (FTweens[i] as TAbstractTween).Parent := Self;
  end;
end;

constructor TWrapTween.Create(const BaseTween: ITween);
begin
  Create([BaseTween]);
end;

procedure TWrapTween.AddToPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    (FTweens[i] as TAbstractTween).AddToPlayList(Tween);
end;

procedure TWrapTween.RemoveFromPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    (FTweens[i] as TAbstractTween).RemoveFromPlayList(Tween);
end;

procedure TWrapTween.DoOverwrite;
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    (FTweens[i] as TAbstractTween).DoOverwrite;
end;

function TWrapTween.GetBaseTween: ITween;
begin
  Result := FTweens[0];
end;

{ TParallelTween }

constructor TParallelTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    if FTweens[i].Duration > FDuration then
      FDuration := FTweens[i].Duration;
  FPosition := FDuration;
end;

procedure TParallelTween.Initialize;
var
  i: Integer;
begin
  FPosition := 0;
  for i := Low(FTweens) to High(FTweens) do
    FTweens[i].Initialize;
end;

procedure TParallelTween.DoUpdate(const DeltaTime: Cardinal);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    FTweens[i].Update(DeltaTime);
end;

{ TSerialTween }

constructor TSerialTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    Inc(FDuration, FTweens[i].Duration);
  FPosition := FDuration;
end;

procedure TSerialTween.Initialize;
begin
  FPosition := 0;
  FTweenIndex := 0;
  if Length(FTweens) <> 0 then
    FTweens[FTweenIndex].Initialize;
end;

procedure TSerialTween.DoUpdate(const DeltaTime: Cardinal);
var
  d: Cardinal;
begin
  if (FTweenIndex < Low(FTweens)) or (FTweenIndex > High(FTweens)) then Exit;

  d := FTweens[FTweenIndex].Update(DeltaTime);
  while FTweens[FTweenIndex].IsCompleted do
  begin
    Inc(FTweenIndex);
    if FTweenIndex > High(FTweens) then Break;
    FTweens[FTweenIndex].Initialize; // [t1, t1]ƓTweenw肳ꂽꍇpɕK{
    if d = 0 then Break;
    d := FTweens[FTweenIndex].Update(d);
  end;
end;

{ TDelayedTween }

constructor TDelayedTween.Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FPreDelay := PreDelay;
  FPostDelay := PostDelay;;
  FDuration := FPreDelay + BaseTween.Duration + FPostDelay;
  FPosition := FDuration;
end;

procedure TDelayedTween.Initialize;
begin
  FPosition := 0;
  FState := Pre;
end;

procedure TDelayedTween.DoUpdate(const DeltaTime: Cardinal);
begin
  case FState of
    Pre:
    begin
      if FPosition >= FPreDelay then
      begin
        BaseTween.Initialize;
        BaseTween.Update(FPosition - FPreDelay);
        FState := Proc;
      end;
    end;
    Proc:
    begin
      BaseTween.Update(DeltaTime);
      if BaseTween.IsCompleted then
        FState := Post;
    end;
    Post: ;
  end;
end;

{ TCycledTween }

constructor TCycledTween.Create(const CycleCount: Cardinal;
  const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FCurrentCount := 0;
  FCycleCount := CycleCount;
  FDuration := BaseTween.Duration * FCycleCount;
  FPosition := FDuration;
end;

procedure TCycledTween.Initialize;
begin
  FPosition := 0;
  FCurrentCount := 0;
  BaseTween.Initialize;
end;

procedure TCycledTween.DoUpdate(const DeltaTime: Cardinal);
var
  d: Cardinal;
begin
  d := BaseTween.Update(DeltaTime);
  while BaseTween.IsCompleted do
  begin
    Inc(FCurrentCount);
    if FCurrentCount >= FCycleCount then Break;
    BaseTween.Initialize;
    if d = 0 then Break;
    d := BaseTween.Update(d);
  end;
end;

{ TTween }

class constructor TTween.Create;
begin
  FContext := TRttiContext.Create;
  FList := TList<ITween>.Create;
  FObjTweens := TObjectDictionary<TObject,TList<ITween>>.Create([doOwnsValues]);
  timeBeginPeriod(1);
  FDefaultOverwrite := True;
  Speed := DEFAULT_SPEED;
  FPrevTime := timeGetTime;
end;

class destructor TTween.Destroy;
begin
  if FTimerId <> 0 then
    timeKillEvent(FTimerId);
  timeEndPeriod(1);
  FList.Free;
  FObjTweens.Free;
end;

class procedure TTween.Abort(Obj: TObject = nil);
var
  i: Integer;
  list: TList<ITween>;
begin
  if Obj = nil then
  begin
    while FList.Count > 0 do
      FList[0].Stop;
  end
  else begin
    if FObjTweens.TryGetValue(Obj, list) then
    begin
      for i := 0 to list.Count-1 do
      begin
        (list[i] as TAbstractTween).Stop;
      end;
      FObjTweens.Remove(Obj);
    end;
  end;
end;

class procedure TTween.AddToPlayList(Obj: TObject; Tween: ITween);
var
  list: TList<ITween>;
begin
  if not FObjTweens.ContainsKey(Obj) then
  begin
    list := TList<ITween>.Create;
    FObjTweens.Add(Obj, list);
    list.Add(Tween);
  end
  else begin
    list := FObjTweens[Obj];
    if not list.Contains(Tween) then
      list.Add(Tween);
  end;
end;

class procedure TTween.RemoveFromPlayList(Obj: TObject; Tween: ITween);
var
  list: TList<ITween>;
begin
  if not FObjTweens.TryGetValue(Obj, list) then Exit;
  if list.Remove(Tween) = -1 then Exit;
  if list.Count <> 0 then Exit;
  FObjTweens.Remove(Obj);
end;

class procedure TTween.TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD);
begin
  TThread.Synchronize(nil, TTween.Update);
end;

class procedure TTween.Update;
var
  i: Integer;
  curTime: Cardinal;
  delta: Cardinal;
begin
  if Assigned(FOnBeforeUpdate) then
    FOnBeforeUpdate;

  i := 0;
  curTime := timeGetTime;
  delta := curTime - FPrevTime;
  while i < FList.Count do
  begin
    FList[i].Update(delta);
    if FList[i].IsCompleted then
    begin
      if FList[i].StopOnComplete then
        FList.Delete(i)
      else
      begin
        FList[i].Initialize;
        Inc(i);
      end;
    end
    else begin
      Inc(i);
    end;
  end;
  FPrevTime := curTime;

  if Assigned(FOnAfterUpdate) then
    FOnAfterUpdate;
end;

class function TTween.Tween(Obj: TObject;  const PropName: string;
  const FromValue, ToValue: Integer; Duration: Cardinal; const Easing: TEasingFunc): ITween;
begin
  Result := TObjectTween.Create(Obj, [PropName, FromValue], [PropName, ToValue], Duration, Easing);
end;

class function TTween.Tween(const Obj: TObject; const FromValues, ToValues: array of const;
  const Duration: Cardinal; const Easing: TEasingFunc): ITween;
begin
  Result := TObjectTween.Create(Obj, FromValues, ToValues, Duration, Easing);
end;

class function TTween.TweenTo(Obj: TObject; const PropName: string;
  const ToValue: Integer; Duration: Cardinal; const Easing: TEasingFunc = nil): ITween;
begin
  Result := TObjectTween.Create(Obj, [], [PropName, ToValue], Duration, Easing);
end;

class function TTween.TweenTo(Obj: TObject; const ToValues: array of const;
  Duration: Cardinal; const Easing: TEasingFunc): ITween;
begin
  Result := TObjectTween.Create(Obj, [], ToValues, Duration, Easing);
end;

class function TTween.TweenFrom(Obj: TObject; const PropName: string;
  const FromValue: Integer; Duration: Cardinal; const Easing: TEasingFunc): ITween;
begin
  Result := TObjectTween.Create(Obj, [PropName, FromValue], [], Duration, Easing);
end;

class function TTween.TweenFrom(Obj: TObject; const FromValues: array of const;
  Duration: Cardinal; const Easing: TEasingFunc): ITween;
begin
  Result := TObjectTween.Create(Obj, FromValues, [], Duration, Easing);
end;

class function TTween.Parallel(const Tweens: array of ITween): ITween;
begin
  Result := TParallelTween.Create(Tweens);
end;

class function TTween.Serial(const Tweens: array of ITween): ITween;
begin
  Result := TSerialTween.Create(Tweens);
end;

class function TTween.Delay(const PreDelay, PostDelay: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TDelayedTween.Create(PreDelay, PostDelay, BaseTween);
end;

class function TTween.Cycle(const CycleCount: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TCycledTween.Create(CycleCount, BaseTween);
end;

class procedure TTween.SetSpeed(const Value: Cardinal);
begin
  if FSpeed = Value then Exit;
  if (Value < 1) or (Value > 1000) then
    raise ETweenException.CreateFmt('Speed1`1000͈̔͂Ŏw肵ĉ (%d)', [Value]);
  FSpeed := Value;
  if FTimerId <> 0 then
    timeKillEvent(FTImerId);
  FTimerId := timeSetEvent(1000 div FSpeed, 1, TimerProc, 0, TIME_PERIODIC);
end;

end.
